// **** BEGIN LICENSE BLOCK ****
//   Copyright(c) 2009 MATSUZAWA Jiro
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA
//   02110-1301, USA.  */
// **** END LICENSE BLOCK ****

var rencon;
if (!rencon) {
    rencon = {};
} else if (typeof rencon != "object") {
    throw new Error("cannot use rencon");
}

////////////////////////////////////////////////////
// public
////////////////////////////////////////////////////
rencon.BibTableManager = function()
{
    this.bibTable = new Array();
    this.index = 0;
}

rencon.BibTableManager.prototype.hasNext = function()
{
    // it's true if there is valid item index
    if (this.getNextIndex() >= 0) {
        return true;
    }

    return false;
}


rencon.BibTableManager.prototype.addRecord = function(
        rec
        )
{
    if (this.bibTable.length >= 0x100000000) {
        return;
    }

    this.bibTable.push(new rencon.BibRecordManager(rec, true) );
    return;
}

rencon.BibTableManager.prototype.getRecord = function()
{
    var i = this.getNextIndex();
    if (i < 0) {
        return null;
    }
    this.index = i;

    return this.bibTable[this.index++].getRecord();
}


rencon.BibTableManager.prototype.delete = function()
{
    delete this.bibTable;
    delete this.index;
}


////////////////////////////////////////////////////
// private
////////////////////////////////////////////////////
rencon.BibTableManager.prototype.
getNextIndex = function()
{
    var i = -1;

    if (this.index >= this.bibTable.length) {
        return -1;
    }

    // if next index is valid and that record's out flag is valid, return taht index
    for (i = this.index; i < this.bibTable.length; ++i) {
        if (this.bibTable[i].getOutFlg() == true) {
            return i;
        }
    }

    return -1;
}
